' This is an example of how to use QSMTP
' K.Bunch - 12/02/07

$TYPECHECK On
$INCLUDE "Rapidq.inc"
$INCLUDE "Providers.inc"
$INCLUDE "QSMTP.inc"

$RESOURCE SendBmp AS "Send.bmp"

DECLARE FUNCTION SetFocus LIB "USER32" ALIAS "SetFocus" (hWnd AS LONG) AS LONG
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG,nIndex AS LONG, dwNewLong AS LONG) AS LONG

DECLARE FUNCTION GetCom(Provider AS INTEGER) AS STRING

DECLARE SUB Initialize
DECLARE SUB SendIt
DECLARE SUB ReWrite(Key AS BYTE)

CREATE Form AS QFORM
    Caption = "SMTP Example"
    Width = 320
    Height = 240
    WindowState = 2
    Center
    OnShow = Initialize
    ShowHint = 1
    CREATE ToolPanel AS QPANEL
        Align = alLeft
        Width = 200
        CREATE ProviderLabel AS QPANEL
            Top = 0
            Left = 5
            Width = ToolPanel.Width - 10
            Height = 20
            Caption = "Select a Provider"
            Alignment = 0
        END CREATE
        CREATE ProviderCb AS QCOMBOBOX
            Top = ProviderLabel.Top + ProviderLabel.Height
            Left = ProviderLabel.Left
            Width = ProviderLabel.Width
            Style = 3
        END CREATE                
        CREATE UsernameLabel AS QPANEL
            Top = ProviderCb.Top + ProviderCb.Height + 10
            Left = 5
            Width = ToolPanel.Width - 10
            Height = 20
            Caption = "Username"
            Alignment = 0
        END CREATE
        CREATE Username AS QEDIT
            Top = UsernameLabel.Top + UserNameLabel.Height
            Left = UsernameLabel.Left
            Width = UsernameLabel.Width
            OnKeyUp = ReWrite
        END CREATE
        CREATE PasswordLabel AS QPANEL
            Top = Username.Top + Username.Height + 10
            Left = 5
            Width = ToolPanel.Width - 10
            Height = 20
            Caption = "Password"
            Alignment = 0
        END CREATE
        CREATE Password AS QEDIT
            Top = PasswordLabel.Top + PasswordLabel.Height
            Left = PasswordLabel.Left
            Width = PasswordLabel.Width
            PasswordChar = "*"
        END CREATE
        CREATE ConfirmPasswordLabel AS QPANEL
            Top = Password.Top + Password.Height + 10
            Left = 5
            Width = ToolPanel.Width - 10
            Height = 20
            Caption = "Confirm Password"
            Alignment = 0
        END CREATE
        CREATE ConfirmPassword AS QEDIT
            Top = ConfirmPasswordLabel.Top + ConfirmPasswordLabel.Height
            Left = ConfirmPasswordLabel.Left
            Width = ConfirmPasswordLabel.Width
            PasswordChar = "*"
        END CREATE
    END CREATE
    CREATE MainPanel AS QPANEL
        Align = alClient
        CREATE InputPanel AS QPANEL
            Align = alTop
            Height = 200
            CREATE BtnPanel AS QPANEL
                Align = alTop
                Height = 25
                CREATE SendBtn AS QCOOLBTN
                    Top = 1
                    Left = 1
                    Width = 75
                    Height = 23
                    Caption = "Send"
                    Hint = "Send Email"
                    BmpHandle = SendBmp
                    OnClick = SendIt
                END CREATE
            END CREATE
            CREATE FromLabel AS QPANEL
                Top = 30
                Left = 5
                Width = 50
                Height = 20
                Caption = "From: "
                Alignment = 1
                Color = RGB(0, 0, 255)
                Font.Color = RGB(255, 255, 255)
            END CREATE
            CREATE From AS QEDIT
                Top = 30
                Left = 55
                Width = 300
            END CREATE
            CREATE ToLabel AS QPANEL
                Top = 55
                Left = 5
                Width = 50
                Height = 20
                Caption = "To: "
                Alignment = 1
                Color = RGB(0, 0, 255)
                Font.Color = RGB(255, 255, 255)
            END CREATE
            CREATE To AS QEDIT
                Top = 55
                Left = 55
                Width = 300
            END CREATE
            CREATE CcLabel AS QPANEL
                Top = 80
                Left = 5
                Width = 50
                Height = 20
                Caption = "Cc: "
                Alignment = 1
                Color = RGB(0, 0, 255)
                Font.Color = RGB(255, 255, 255)
            END CREATE
            CREATE Cc AS QEDIT
                Top = 80
                Left = 55
                Width = 300
            END CREATE
            CREATE BccLabel AS QPANEL
                Top = 105
                Left = 5
                Width = 50
                Height = 20
                Caption = "Bcc: "
                Alignment = 1
                Color = RGB(0, 0, 255)
                Font.Color = RGB(255, 255, 255)
            END CREATE
            CREATE Bcc AS QEDIT
                Top = 105
                Left = 55
                Width = 300
            END CREATE
            CREATE SubjectLabel AS QPANEL
                Top = 130
                Left = 5
                Width = 50
                Height = 20
                Caption = "Subject: "
                Alignment = 1
                Color = RGB(0, 0, 255)
                Font.Color = RGB(255, 255, 255)
            END CREATE
            CREATE Subject AS QEDIT
                Top = 130
                Left = 55
                Width = 300
            END CREATE
            CREATE StyleGb AS QGROUPBOX
                Top = Subject.Top + 25
                Left = 5
                Width = 180
                Height = 40
                Caption = "Style"
                Font.Color = RGB(0, 0, 255)
                Font.AddStyles(fsBold)
                CREATE TextStyle AS QRADIOBUTTON
                    Top = 15
                    Left = 30
                    Width = 50
                    Caption = "Text"
                    Checked = 1
                    Font.Color = 0
                    Font.DelStyles(fsBold)
                END CREATE
                CREATE HTMLStyle AS QRADIOBUTTON
                    Top = 15
                    Left = 100
                    Width = 50
                    Caption = "Html"
                    Font.Color = 0
                    Font.DelStyles(fsBold)
                END CREATE
            END CREATE
        END CREATE
        CREATE Message AS QRICHEDIT
            Align = alClient
            HideScrollbars = 0
            Scrollbars = ssBoth
            Wordwrap = 0
            PlainText = 1
        END CREATE
    END CREATE
END CREATE

DEFINT Amount
DEFINT RetVal

SetWindowLong(Form.Handle, -8, 0)
SetWindowLong(Application.Handle, -8, Form.Handle)

Form.ShowModal

SUB SendIt
    IF Password.Text <> ConfirmPassword.Text THEN
        Messagedlg("Your password does not match your confirm password." + CHR$(13) + "Please try again.", mtWarning, mbOK, 0)
        Password.Text = ""
        ConfirmPassword.Text = ""
        PasswordLabel.Font.Color = 255
        ConfirmPasswordLabel.Font.Color = 255
        SetFocus(Password.Handle)
    ELSE
        PasswordLabel.Font.Color = 0
        ConfirmPasswordLabel.Font.Color = 0
        RetVal = SendSMTP(Server(ProviderCb.ItemIndex), Username.Text, Password.Text, From.Text, To.Text, Cc.Text, Bcc.Text, Subject.Text, Message.Text, HtmlStyle.Checked)
        IF RetVal = 1 THEN Messagedlg("Message was successfully sent.", mtInformation, mbOK, 0)
    END IF
END SUB

SUB ReWrite(Key AS BYTE)
    IF From.Text = "" THEN Username.Text = ""
    From.Text = Username.Text + "@" + GetCom(ProviderCb.ItemIndex)
END SUB

FUNCTION GetCom(Provider AS INTEGER) AS STRING
    DEFSTR Com
    IF TALLY(Server(Provider), ".") = 1 THEN
        GetCom = Server(Provider)
    ELSE
        Com = Server(Provider)
        DO
            Com = DELETE$(Com, 1, 1)
        LOOP UNTIL TALLY(Com, ".") = 1
        GetCom = Com
    END IF
END FUNCTION

SUB Initialize
    FOR Amount = 0 TO 343
        ProviderCb.AddItems Provider(Amount)
    NEXT Amount
    ProviderCb.ItemIndex = 0
END SUB
